/**
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in compliance
 * with the License. You may obtain a copy of the License at
 * 
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.
 * See the License for the specific language governing rights and
 * limitations under the License.
 * 
 * The Original Code is SomaDebugger.
 * 
 * The Initial Developer of the Original Code is Romuald Quantin.
 * romu@soundstep.com (www.soundstep.com).
 * 
 * Portions created by
 * 
 * Initial Developer are Copyright (C) 2008-2010 Soundstep. All Rights Reserved.
 * All Rights Reserved.
 * 
 */
 
 package com.soma.debugger.events {
	import flash.events.Event;

	/**
	 * <b>Author:</b> Romuald Quantin - <a href="http://www.soundstep.com/" target="_blank">www.soundstep.com</a><br />
	 * <b>Class version:</b> v2.0.0<br />
	 * <b>Actionscript version:</b> 3.0<br />
	 * <b>Copyright:</b>
	 * Mozilla Public License 1.1 (MPL 1.1)<br /> 
	 * <a href="http://www.opensource.org/licenses/mozilla1.1.php" target="_blank">http://www.opensource.org/licenses/mozilla1.1.php</a><br />
	 * <br />
	 * <b>Usage:</b><br />
	 * @example
	 * <listing version="3.0">
	 * </listing>
	 */
	
	public class SomaDebuggerEvent extends Event {

		//------------------------------------
		// private, protected properties
		//------------------------------------
		
		//------------------------------------
		// public properties
		//------------------------------------
		
		public static const SHOW_DEBUGGER:String = "Soma::SomaDebuggerEvent.SHOW_DEBUGGER";
		public static const HIDE_DEBUGGER:String = "Soma::SomaDebuggerEvent.HIDE_DEBUGGER";
		public static const MOVE_TO_TOP:String = "Soma::SomaDebuggerEvent.MOVE_TO_TOP";
		public static const PRINT:String = "Soma::SomaDebuggerEvent.PRINT";
		public static const CLEAR:String = "Soma::SomaDebuggerEvent.CLEAR";
		
		public var message:Object;
		public var info:String;
		public var debuggerName:String;

		//------------------------------------
		// constructor
		//------------------------------------
		
		public function SomaDebuggerEvent(type:String, message:Object = null, info:String = null, debuggerName:String = null, bubbles:Boolean = true, cancelable:Boolean = false) {
			this.message = message;
			this.info = info;
			this.debuggerName = debuggerName;
			super(type, bubbles, cancelable);
		}
		
		//
		// PRIVATE, PROTECTED
		//________________________________________________________________________________________________
		
		//
		// PUBLIC
		//________________________________________________________________________________________________
		
		override public function clone():Event {
			return new SomaDebuggerEvent(type, message, info, debuggerName, bubbles, cancelable);
		}
		
		override public function toString():String {
			return formatToString("SomaDebuggerEvent", "message", "info", "debuggerName", "type", "bubbles", "cancelable", "eventPhase");
		}
		
	}
}
