package com.soundstep.somacolor.controllers.events {
	import flash.display.DisplayObject;
	import flash.events.Event;

	/**
	 * <b>Author:</b> Romuald Quantin - <a href="http://www.soundstep.com/" target="_blank">www.soundstep.com</a><br />
	 * <b>Class version:</b> 1.0<br />
	 * <b>Actionscript version:</b> 3.0<br />
	 * <b>Copyright:</b> 
	 * <br />
	 * <b>Date:</b> Sep 22, 2009<br />
	 * <b>Usage:</b>
	 * @example
	 * <listing version="3.0"></listing>
	 */
	
	public class TweenEvent extends Event {

		//------------------------------------
		// private, protected properties
		//------------------------------------
		
		//------------------------------------
		// public properties
		//------------------------------------
		
		public static const TWEEN:String = "tween";
		
		public var tweenTarget:DisplayObject;
		public var tweenTime:Number;
		public var tweenObject:Object;

		//------------------------------------
		// constructor
		//------------------------------------
		
		public function TweenEvent(type:String, tweenTarget:DisplayObject, tweenTime:Number, tweenObject:Object, bubbles:Boolean = true, cancelable:Boolean = false) {
			this.tweenTarget = tweenTarget;
			this.tweenTime = tweenTime;
			this.tweenObject = tweenObject;
			super(type, bubbles, cancelable);
		}
		
		//
		// PRIVATE, PROTECTED
		//________________________________________________________________________________________________
		
		//
		// PUBLIC
		//________________________________________________________________________________________________
		
		override public function clone():Event {
			return new TweenEvent(type, tweenTarget, tweenTime, tweenObject, bubbles, cancelable);
		}
		
		override public function toString():String {
			return formatToString("TweenEvent", "tweenTarget", "tweenTime", "tweenObject", "type", "bubbles", "cancelable", "eventPhase");
		}
		
	}
}
