package com.soundstep.demo.somacore.gc.views {
	import com.soundstep.demo.somacore.gc.events.ItemEvent;
	import flash.events.MouseEvent;
	import flash.display.Sprite;

	/**
	 * <b>Author:</b> Romuald Quantin - <a href="http://www.soundstep.com/" target="_blank">www.soundstep.com</a><br />
	 * <b>Company:</b> Less Rain - <a href="http://www.lessrain.com/" target="_blank">www.lessrain.com</a><br />
	 * <b>Class version:</b> 1.0<br />
	 * <b>Actionscript version:</b> 3.0<br />
	 * <b>Copyright:</b> 
	 * <br />
	 * <b>Date:</b> Jan 11, 2010<br />
	 * <b>Usage:</b>
	 * @example
	 * <listing version="3.0"></listing>
	 */
	
	public class ItemView extends Sprite {

		//------------------------------------
		// private, protected properties
		//------------------------------------
		
		private var _id:int;
		
		//------------------------------------
		// public properties
		//------------------------------------
		

		//------------------------------------
		// constructor
		//------------------------------------
		
		public function ItemView(id:int) {
			_id = id;
			initialize();
		}

		//
		// PRIVATE, PROTECTED
		//________________________________________________________________________________________________
		
		public function initialize():void {
			buttonMode = true;
			mouseChildren = false;
			graphics.beginFill(Math.random() * 0xFFFFFF);
			graphics.drawCircle(0, 0, 30);
			addEventListener(MouseEvent.CLICK, clickHandler);
		}
		
		private function clickHandler(e:MouseEvent):void {
			dispatchEvent(new ItemEvent(ItemEvent.DESTROY, _id));
		}
		
		// PUBLIC
		//________________________________________________________________________________________________
		
		public function dispose():void {
			removeEventListener(MouseEvent.CLICK, clickHandler);
		}
		
		public function get id() : int {
			return _id;
		}
	}
}
