package com.soundstep.demo.somacore.gc.wires {
	import com.soma.core.interfaces.IWire;
	import com.soma.core.wire.Wire;
	import com.soundstep.demo.somacore.gc.SomaApplication;
	import com.soundstep.demo.somacore.gc.events.ItemEvent;

	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;

	/**
	 * <b>Author:</b> Romuald Quantin - <a href="http://www.soundstep.com/" target="_blank">www.soundstep.com</a><br />
	 * <b>Company:</b> Less Rain - <a href="http://www.lessrain.com/" target="_blank">www.lessrain.com</a><br />
	 * <b>Class version:</b> 1.0<br />
	 * <b>Actionscript version:</b> 3.0<br />
	 * <b>Copyright:</b> 
	 * <br />
	 * <b>Date:</b> Jan 11, 2010<br />
	 * <b>Usage:</b>
	 * @example
	 * <listing version="3.0"></listing>
	 */
	
	public class MainWire extends Wire implements IWire {

		//------------------------------------
		// private, protected properties
		//------------------------------------
		
		private var _count:int = 0;

		//------------------------------------
		// public properties
		//------------------------------------
		
		public static const NAME:String = "Wire::MainWire";
		
		//------------------------------------
		// constructor
		//------------------------------------
		
		public function MainWire() {
			super(NAME);
		}
		
		//
		// PRIVATE, PROTECTED
		//________________________________________________________________________________________________
		
		override public function initialize():void {
			stage.addEventListener(MouseEvent.CLICK, createItem);
		}
		
		override public function dispose():void {
			stage.removeEventListener(MouseEvent.CLICK, createItem);
		}
		
		private function createItem(e:MouseEvent):void {
			if (e.target != stage) return;
			dispatchEvent(new ItemEvent(ItemEvent.CREATE, _count++));
		}
		
		// PUBLIC
		//________________________________________________________________________________________________
		
		public function createInfo():void {
			var str:String = "Garbage Collection Monitor Demo\n";
			str += "    - click on the stage to create circles\n";
			str += "    - click on the circles to destroy them\n";
			str += "    - click on the garbage collection bar in the debugger to watch the collection\n";
			str += "    - click on the force button to force the garbage collection (working with Flash Player Debugger)";
			var tf:TextFormat = new TextFormat("_typewriter", 11, 0xFFFFFF);
			var textfield:TextField = new TextField();
			textfield.defaultTextFormat = tf;
			textfield.selectable = false;
			textfield.multiline = true;
			textfield.autoSize = TextFieldAutoSize.LEFT;
			textfield.text = str;
			textfield.x = 5;
			textfield.y = 5;
			SomaApplication(instance).main.addChild(textfield);
		}

	}
}
